#include "ti86asm.inc"

 .org _asm_exec_ram
 
    nop
    jp prog_start
    .dw 0
    .dw comment
    
comment:
    .text "Save custom menu to a program"

prog_start: 
    call _clrLCD
    call _homeup
    ld hl,start_t                   ;"Press enter to create" new line "custom restore prog!"
    call puts_line                  ;call _puts and call _newline

    call _getkey
    
    cp kEnter
    ret nz                          ;exit if not enter pressed


;copy the custom menu to the end of the program to create
    ld de,end                       ;end of the program
    ld hl,$d1c3                     ;custom menu slots
    ld bc,182                       ;182 bytes to copy
    ldir

find_name:
    ld hl,prog+8                    ;hl = number in name of program to create
    ld a,'9'                        ;is it 9
    cp (hl)
    jp z,all_slots_used             ;then we can't create the program
    inc (hl)                        ;else increase the number

    ld hl,prog-1                    ;name of prog, the type byte is not needed
    rst 20h                         ;= call _mov10toop1, move 10 bytes from hl to OP1
    rst 10h                         ;= call _findsym, find varible with name in OP1

    jp nc,find_name                 ;try with next name if this one existed
    ld hl,prog_size                 ;how big the program will be
    call _CREATEPROG                ;create a program with OP1 as name and hl as size
;    call _ex_ahl_bde               ;_createprog stores address to bde, we want it to ahl
    ld a,b                          ;this method is one byte shorter, but the old ahl is not saved
    ex de,hl
        
    call _AHL_PLUS_2_PG3            ;ignore the two firs bytes (size)
    call _SET_ABS_DEST_ADDR         ;set the address as destination for the copy
    
    xor a                           ;because it's ram page 0 a is just zero
    ld hl,copy_start                ;hl is the actual address
    call _SET_ABS_SRC_ADDR          ;set as source
    
    xor a
    ld hl,prog_size                 ;ahl = number of bytes to copy
    call _SET_MM_NUM_BYTES          ;set it

    call _MM_LDIR                   ;do the block copy, can't use ldir since it doesn't handle ram page swapping

    ld hl,end_t1
    call _newline                   ;"Run Asm(custback) to" new line "restore custom menu!"
    call _puts                      ;"Run Asm("
    call _putps                     ;"custbck(0-9)
    call puts_line                  ;) to restore custom menu!
    jp _getkey                      ;just wait for a keypress before exiting
;    ret
                      

all_slots_used:
    call _newline
    ld hl,used_t
    call puts_line
    jp _getkey
    
used_t:
    .text "All custbck slots arealready used!"

start_t:
    .text "Press enter to createcustom restore prog!"

end_t1:
    .text "Run Asm("
prog:
    .db 8,"custbck",'0'-1;                  ;lenght indexed name of the program to create
                                            ;last byte is the nuber, being increased every now and then
end_t2
    .text ") to restore custom menu!"

      
;this is the beginning of the program to create
copy_start:
    .dw $288e                       ;asm prog identifier

start:

    nop
    jp _asm_exec_ram-start+prog2_start
    .dw 0
    .dw _asm_exec_ram-start+comment2
    
comment2:
    .text "Restore custom menu"

prog2_start:
;here the actual program starts
    call _clrLCD
    call _homeup
    ld hl,_asm_exec_ram-start+rest_t    ;need to do this to get the addressing correct because the assemlber doesn't know that this is a new program
    call _asm_exec_ram-start+puts_line  ;"Press enter to" newline
    call _asm_exec_ram-start+puts_line  ;"resote custom menu!" newline
    call _getkey
    
    cp kEnter
    ret nz                              ;return if enter not pressed

;copy the custom menu
    ld de,$d1c3                         ;destination
    ld hl,_asm_exec_ram-start+end       ;source
    ld bc,182                           ;lenght
    ldir
    
    ld hl,_asm_exec_ram-start+done_t    ;"Custom menu restored!"
    call _puts
    call _getkey                        ;wait for a keypress

;delete the program (custback)
    ld hl,_asapvar                      ;name of currently running program
    rst 20h                             ;call _mov10toop1
    rst 10h                             ;call _findsym
    jp _delvar                          ;uses the output of _findsym, delete and use _delvar's ret


;theese two calls are used after each others so many times that the program get shorter if theyr'e grouped
puts_line:
    call _puts
    jp _newline                         ;use _newline's ret instead, saves one byte
;    ret

rest_t:
    .text "Press enter to"
    .text "restore custom menu!"

done_t:
    .text "Custom menu restored!"
        
end:
prog_size   = end-start+2+182           ;total lenght of the program. + two indentifier btes + 182 bytes custom memu

.end